{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvButtonShaped.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvButtonShaped;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, JvButton, JvRegion;

type
  TJvButtonShaped = class(TJvButton)
  private
    FReg: TJvRegion;
    FWorking: boolean;
    FShape: TBitmap;
    procedure SetShape(const Value: TBitmap);
  protected
    procedure CreateWnd; override;
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
  published
    property Shape:TBitmap read FShape write SetShape;
  end;

implementation

{*******************************************************}
constructor TJvButtonShaped.Create(AOwner: TComponent);
begin
  inherited;
  FShape := TBitmap.Create;
  FReg := TJvRegion.Create(self);
  FWorking := false;
end;
{*******************************************************}
procedure TJvButtonShaped.CreateWnd;
begin
  if FShape.Empty=false then
  begin
    inherited;
    Shape := Shape;
  end;
end;
{*******************************************************}
destructor TJvButtonShaped.Destroy;
begin
  FShape.Free;
  FReg.Free;
  inherited;
end;
{*******************************************************}
procedure TJvButtonShaped.SetShape(const Value: TBitmap);
begin
  FShape.Assign(Value);
  if not(FWorking)then
  begin
    try
      FWorking := true;
      SetWindowRgn(Handle,FReg.RegionFromBitmap(Value),true);
    finally
      FWorking := false;
    end;
  end;
  FWorking := false;
end;
{*******************************************************}
end.
