{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvCpuUsage.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvCpuUsage;

{$ObjExportAll On} 

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Registry;

type
  TJvCpuUsage = class(TComponent)
  private
    FStatistic : string ;
    FValue:Cardinal;
    FUsage:string;
    FRegistry:TRegistry;
    function GetUsage:string;
  protected
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
  published
    property Usage:string read GetUsage write FUsage;
  end;

implementation

resourcestring
   RC_CpuUsageKey       =   'KERNEL\CPUUsage';
   RC_PerfStart         =   'PerfStats\StartStat';
   RC_PerfStop          =   'PerfStats\StopStat';
   RC_PerfStat          =   'PerfStats\StatData';

{*****************************************************}
constructor TJvCpuUsage.Create(AOwner: TComponent);
begin
   inherited;
   FStatistic:=RC_CpuUsageKey;
   FRegistry:=TRegistry.Create;
   FRegistry.RootKey := HKEY_DYN_DATA ;
   FRegistry.OpenKey (RC_PerfStart, false) ;
   FRegistry.ReadBinaryData (FStatistic, FValue, sizeof (FValue)) ;
end;
{*****************************************************}
destructor TJvCpuUsage.Destroy;
begin
   FRegistry.OpenKey (RC_PerfStop, false) ;
   FRegistry.ReadBinaryData(FStatistic,FValue,sizeof(FValue));
   FRegistry.CloseKey;
   FRegistry.free;
   inherited;
end;
{*****************************************************}
function TJvCpuUsage.GetUsage:string;
begin
   FRegistry.OpenKey (RC_PerfStat, false) ;
   FRegistry.ReadBinaryData (FStatistic, FValue, sizeof (FValue)) ;
   Fregistry.CLoseKey;
   result:=IntToStr(FValue);
end;
{*****************************************************}
end.
