{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvEasterEgg.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvEasterEgg;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, JvTypes;

type
  TJvEasterEgg = class(TComponent)
  private
    FActive: boolean;
    FOnEgg: TNotifyEvent;
    FShiftState: TShiftState;
    FEggs: string;
    FForm: TCustomForm;
    FOldWndProc: Pointer;
    FCurstring: string;
    procedure NewWndProc(var Msg:TMessage);
  protected
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
  published
    property Active:boolean read FActive write FActive default true;
    property Egg:string read FEggs write FEggs;
    property ControlKeys:TShiftState read FShiftState write FShiftState default [ssAlt];
    property OnEggFound:TNotifyEvent read FOnEgg write FOnEgg;
  end;

implementation

{**************************************************}
constructor TJvEasterEgg.Create(AOwner: TComponent);
var
 ptr: pointer;
begin
  inherited;
  FOldWndProc := nil;
  FForm:= GetParentForm(TControl(AOwner));
  FActive := true;
  FShiftState := [ssAlt];

  FOldWndProc := Pointer(GetWindowLong(FForm.Handle,GWL_WNDPROC));
  ptr := MakeObjectInstance(NewWndProc);
  SetWindowLong(FForm.Handle, GWL_WNDPROC, Longint(ptr));
end;
{**************************************************}
destructor TJvEasterEgg.Destroy;
begin
  if not(csDestroying in FForm.ComponentState) then
    SetWindowLong(FForm.Handle, GWL_WNDPROC, LongInt(FOldWndProc));
  inherited;
end;
{**************************************************}
procedure TJvEasterEgg.NewWndProc(var Msg: TMessage);
var
 shift: TShiftState;
begin
  with Msg do
  begin
    if (FActive)and(FEggs<>'') then
    begin
      case Msg of
         WM_KEYUP, WM_SYSKEYUP  :
           begin
             Result:=CallWindowProc(FOldWndProc,FForm.Handle,Msg,WParam,LParam);
             shift:=KeyDataToShiftState(lParam);
             if shift=FShiftState then
             begin
               if ssShift in shift then
                 FCurstring:=FCurstring+UpCase(char(wParam))
               else
                 FCurstring:=FCurstring+LowerCase(char(wParam))[1];
               if FCurstring=FEggs then
               begin
                 if Assigned(FOnEgg) then
                   FOnEgg(self);
                 FCurstring:='';
               end
               else
                 if length(FCurstring)>=length(FEggs) then
                   FCurstring:=Copy(FCurstring,2,length(FEggs));
             end;
           end;
         else
           Result:=CallWindowProc(FOldWndProc,FForm.Handle,Msg,WParam,LParam);
      end;
    end
    else
      Result:=CallWindowProc(FOldWndProc,FForm.Handle,Msg,WParam,LParam);
  end;
end;
{**************************************************}
end.
