{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvExecute.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvExecute;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,  ShellApi, Forms;

type
  TJvExecute = class(TComponent)
  private
  protected
  public
  published
    procedure exec(FileName,parameters,directory:string);
    procedure ExecuteAndWait(FileName:string;visibility:integer);
  end;

implementation

{**************************************************}
procedure TJvExecute.exec(FileName,parameters,directory:string);
var
   operation:string;
begin
   operation:='open';
   ShellExecute(Application.handle,pchar(operation),pchar(FileName),pchar(parameters),pchar(directory),SW_SHOWNORMAL);
end;
{**************************************************}
procedure TJvExecute.ExecuteAndWait(FileName:string;visibility:integer);
var
   zAppName:array[0..512] of char;
   zCurDir:array[0..255] of char;
   WorkDir:string;
   StartupInfo:TStartupInfo;
   ProcessInfo:TProcessInformation;
begin
   StrPCopy(zAppName,FileName);  GetDir(0,WorkDir);
   StrPCopy(zCurDir,WorkDir);  FillChar(StartupInfo,Sizeof(StartupInfo),#0);
   StartupInfo.cb := Sizeof(StartupInfo);
   StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
   StartupInfo.wShowWindow := Visibility;
   if not(CreateProcess(nil,zAppName,nil,nil,false,Create_NEW_CONSOLE or NORMAL_PRIORITY_CLASS,
      nil,nil,StartupInfo,ProcessInfo)) then
   WaitforSingleObject(ProcessInfo.hProcess,INFINITE);
end;
{**************************************************}
end.
