{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvExitWindows.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvExitWindows;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, 
  JvTypes, Registry;

type
  TJvExitWindows = class(TComponent)
  private
  protected
  public
  published
    function RestartWindows:boolean;
    function RebootSystem:boolean;
    function ForceRebooting:boolean;
    function LogOffUser:boolean;
    function PowerOff:boolean;
    function ShutDown:boolean;
    procedure ExecOnceRebooted(apps:string);
  end;

implementation

resourcestring
  RC_RunOnceKey       =        'Software\Microsoft\Windows\CurrentVersion\RunOnce';

{******************************************************}
function TJvExitWindows.RestartWindows:boolean;
begin
   result:=ExitWindows(EW_RESTARTWINDOWS,0);
end;
{******************************************************}
function TJvExitWindows.RebootSystem:boolean;
begin
   result:=ExitWindows(EW_REBOOTSYSTEM,0);
end;
{******************************************************}
function TJvExitWindows.ForceRebooting:boolean;
begin
   result:=ExitwindowsEx(EWX_FORCE,0);
end;
{******************************************************}
function TJvExitWindows.LogOffUser:boolean;
begin
   result:=ExitWindowsEx(EWX_LOGOFF,0);
end;
{******************************************************}
function TJvExitWindows.PowerOff:boolean;
begin
   result:=ExitWindowsEx(EWX_POWEROFF,0);
end;
{******************************************************}
function TJvExitWindows.ShutDown:boolean;
begin
   result:=ExitWindowsEx(EWX_SHUTDOWN,0);
end;
{******************************************************}
procedure TJvExitWindows.ExecOnceRebooted(apps:string);
begin
   with TRegistry.Create do
   begin
      rootkey:=HKEY_LOCAL_MACHINE;
      OpenKey(RC_RunOnceKey,false);
      WriteString('ToRun',apps);
      free;
   end;
end;
{******************************************************}
end.
