{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvFormAlarms.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvFormAlarms;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, JvButton;

type
  TAlarmInf = class
        AlarmTime:TDateTime;    
  end;
  TFormAlarm = class(TForm)
    ListBox1: TListBox;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    DateTimePicker2: TDateTimePicker;
    BUButton1: TJvButton;
    BUButton2: TJvButton;
    BUButton3: TJvButton;
    BUButton4: TJvButton;
    DateTimePicker1: TDateTimePicker;
    procedure BUButton3Click(Sender: TObject);
    procedure BUButton4Click(Sender: TObject);
    procedure BUButton1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure BUButton2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure DateTimePicker2Change(Sender: TObject);
  private
  public
    procedure LoadFromStr(Value:TstringList);
    function SetFromStr:TstringList;
  end;

implementation

{$R *.DFM}

{************************************************************}
procedure TFormAlarm.BUButton3Click(Sender: TObject);
begin
   self.close;
end;
{************************************************************}
procedure TFormAlarm.LoadFromStr(Value: TstringList);
var
   i:Integer;
   al:TAlarmInf;
begin
   for i:=0 to Value.count-1 do
   begin
      al:=TAlarmInf.Create;
      al.AlarmTime:=StrToDateTime(Copy(Value[i],1,pos('|',Value[i])-1));
      self.listbox1.items.AddObject(Copy(Value[i],pos('|',Value[i])+1,length(Value[i])),TObject(al));
   end;
end;
{************************************************************}
function TFormAlarm.SetFromStr: TstringList;
var
   i:Integer;
begin
   result:=TstringList.Create;
   for i:=0 to self.listbox1.Items.count-1 do
      result.add(DateTimeToStr(TAlarmInf(self.listbox1.items.objects[i]).AlarmTime)+'|'+self.listbox1.items[i]);
end;
{************************************************************}
procedure TFormAlarm.BUButton4Click(Sender: TObject);
begin
   self.tag:=0;
   self.close;
end;
{************************************************************}
procedure TFormAlarm.BUButton1Click(Sender: TObject);
var
   al:TAlarmInf;
begin
   al:=TAlarmInf.Create;
   al.AlarmTime:=now;
   self.listbox1.itemindex:=self.ListBox1.items.addobject('New',TObject(al));
   self.ListBox1DblClick(self);
end;
{************************************************************}
procedure TFormAlarm.ListBox1DblClick(Sender: TObject);
begin
   self.GroupBox1.enabled:=true;
   self.Edit1.Text:=self.ListBox1.items[self.listbox1.itemindex];
   self.DateTimePicker2.time:=StrToTime(TimeToStr(TAlarmInf(self.listbox1.items.objects[self.listbox1.itemindex]).AlarmTime));
   self.DateTimePicker1.date:=StrToDate(DateToStr(TAlarmInf(self.listbox1.items.objects[self.listbox1.itemindex]).AlarmTime));
end;
{************************************************************}
procedure TFormAlarm.BUButton2Click(Sender: TObject);
var
   i:Integer;
begin
   i:=0;
   while i<self.listbox1.items.count do
   begin
      if self.listbox1.Selected[i] then
        self.listbox1.items.delete(i)
      else
        inc(i);
   end;
   if self.listbox1.items.count>0 then
      self.listbox1.itemindex:=0
   else
      self.groupbox1.enabled:=false; 
end;
{************************************************************}
procedure TFormAlarm.Edit1Change(Sender: TObject);
begin
   self.listbox1.items[self.listbox1.itemindex]:=self.Edit1.text;
end;
{************************************************************}
procedure TFormAlarm.DateTimePicker2Change(Sender: TObject);
begin
   TAlarmInf(self.listbox1.items.objects[self.listbox1.itemindex]).AlarmTime:=StrToDateTime(DateToStr(self.DateTimePicker1.date)+' '+TimeToStr(self.DateTimePicker2.time));
end;
{************************************************************}
end.
