{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvFormCalculator.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvFormCalculator;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, JvSpeedButton, JvEdit;

type
  operation = (nothing,plus,minus,fois,division);
  TFormCalc = class(TForm)
    BUSpeedButton1: TJvSpeedButton;
    BUSpeedButton2: TJvSpeedButton;
    BUSpeedButton3: TJvSpeedButton;
    BUSpeedButton4: TJvSpeedButton;
    BUSpeedButton5: TJvSpeedButton;
    BUSpeedButton6: TJvSpeedButton;
    BUSpeedButton7: TJvSpeedButton;
    BUSpeedButton8: TJvSpeedButton;
    BUSpeedButton9: TJvSpeedButton;
    BUSpeedButton10: TJvSpeedButton;
    BUSpeedButton11: TJvSpeedButton;
    BUSpeedButton12: TJvSpeedButton;
    BUSpeedButton13: TJvSpeedButton;
    BUSpeedButton14: TJvSpeedButton;
    BUSpeedButton15: TJvSpeedButton;
    BUSpeedButton16: TJvSpeedButton;
    BUSpeedButton17: TJvSpeedButton;
    BUSpeedButton18: TJvSpeedButton;
    BUSpeedButton19: TJvSpeedButton;
    BUSpeedButton20: TJvSpeedButton;
    BUSpeedButton21: TJvSpeedButton;
    Label1: TLabel;
    BUSpeedButton22: TJvSpeedButton;
    BUSpeedButton23: TJvSpeedButton;
    BUSpeedButton24: TJvSpeedButton;
    edit1: TJvEdit;
    procedure BUSpeedButton1Click(Sender: TObject);
    procedure BUSpeedButton11Click(Sender: TObject);
    procedure BUSpeedButton17Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BUSpeedButton14Click(Sender: TObject);
    procedure BUSpeedButton13Click(Sender: TObject);
    procedure BUSpeedButton16Click(Sender: TObject);
    procedure BUSpeedButton15Click(Sender: TObject);
    procedure BUSpeedButton12Click(Sender: TObject);
    procedure BUSpeedButton19Click(Sender: TObject);
    procedure BUSpeedButton20Click(Sender: TObject);
    procedure BUSpeedButton21Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    function calc:boolean;
    procedure BUSpeedButton22Click(Sender: TObject);
    procedure BUSpeedButton23Click(Sender: TObject);
    procedure BUSpeedButton24Click(Sender: TObject);
    function  GetResult:extended;
    procedure SetResult(Value:extended);
  private
  public
  end;

var
  FormCalc: TFormCalc;
  val,mval:extended;
  op:operation;

implementation

{$R *.DFM}

{******************************************************************************}
function TFormCalc.GetResult:extended;
begin
   if self.edit1.text<>'' then result:=strtofloat(self.edit1.text)
   else result:=0;
end;
{******************************************************************************}
procedure TFormCalc.SetResult(Value:extended);
begin
   self.edit1.text:=floattostr(Value);
end;
{******************************************************************************}
function TFormCalc.calc:boolean;
begin
   result:=true;
   if (self.edit1.text<>'')and(self.edit1.alignment=taLeftJustify) then
   begin
      case op of
           plus:  self.edit1.text:=floattostr(val+strtofloat(self.edit1.text));
           minus: self.edit1.text:=floattostr(val-strtofloat(self.edit1.text));
           fois:  self.edit1.text:=floattostr(val*strtofloat(self.edit1.text));
           division: if strtofloat(self.edit1.text)<>0 then self.edit1.text:=floattostr(val/strtofloat(self.edit1.text))
                     else
                     begin
                        ShowMessage('You cannot divide by zero !');
                        result:=false;
                     end;
      end;
   end
   else result:=false;
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton1Click(Sender: TObject);
begin
   if self.edit1.alignment=taRightJustify then
   begin
      self.edit1.text:='';
      self.edit1.alignment:=taLeftJustify;
   end;
   if self.edit1.text='0' then self.edit1.text:='';
   self.edit1.text:=self.edit1.text+(Sender as TJvspeedbutton).caption;
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton11Click(Sender: TObject);
begin
   self.edit1.clear;
   val:=0;
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton17Click(Sender: TObject);
begin
   if calc then
   begin
      label1.caption:='=';
      val:=strtofloat(self.edit1.text);
      op:=nothing;
      self.edit1.alignment:=taRightJustify;
   end;
end;
{******************************************************************************}
procedure TFormCalc.FormCreate(Sender: TObject);
begin
   val:=0;mval:=0;
   op:=nothing;
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton14Click(Sender: TObject);
begin
   if calc then
   begin
      val:=strtofloat(self.edit1.text);
      self.edit1.text:=floattostr(val);
      self.edit1.Alignment:=taRightJustify;
   end;
   op:=plus;
   self.label1.caption:='+';
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton13Click(Sender: TObject);
begin
   if calc then
   begin
      calc;
      val:=strtofloat(self.edit1.text);
      self.edit1.text:=floattostr(val);
      self.edit1.Alignment:=taRightJustify;
   end;
   op:=fois;
   self.label1.caption:='*';
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton16Click(Sender: TObject);
begin
   if calc then
   begin
      val:=strtofloat(self.edit1.text);
      self.edit1.text:=floattostr(val);
      self.edit1.Alignment:=taRightJustify;
   end;
   op:=minus;
   self.label1.caption:='-';
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton15Click(Sender: TObject);
begin
   if calc then
   begin
      calc;
      val:=strtofloat(self.edit1.text);
      self.edit1.text:=floattostr(val);
      self.edit1.Alignment:=taRightJustify;
   end;
   op:=division;
   self.label1.caption:='/';
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton12Click(Sender: TObject);
begin
   if self.edit1.alignment=taLeftJustify then
   begin
      try
         strtofloat(self.edit1.text+',0');
         self.edit1.text:=self.edit1.text+',';
      except
         self.edit1.text:=edit1.text+'.';
      end;
   end
   else
    beep;
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton19Click(Sender: TObject);
begin
   try
      mval:=strtofloat(self.edit1.text);
   except
   end;
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton20Click(Sender: TObject);
begin
   self.edit1.alignment:=taLeftJustify;
   self.edit1.text:=floattostr(mval);
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton21Click(Sender: TObject);
begin
   self.edit1.clear;
   self.edit1.alignment:=taLeftJustify;
end;
{******************************************************************************}
procedure TFormCalc.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
   case key of
        '0'..'9': begin
                     if self.edit1.alignment=taRightJustify then
                     begin
                        self.edit1.text:='';
                        self.edit1.alignment:=taLeftJustify;
                     end;
                     if self.edit1.text='0' then self.edit1.text:='';
                     case key of
                          '1': self.edit1.text:=self.edit1.text+'1';
                          '2': self.edit1.text:=self.edit1.text+'2';
                          '3': self.edit1.text:=self.edit1.text+'3';
                          '4': self.edit1.text:=self.edit1.text+'4';
                          '5': self.edit1.text:=self.edit1.text+'5';
                          '6': self.edit1.text:=self.edit1.text+'6';
                          '7': self.edit1.text:=self.edit1.text+'7';
                          '8': self.edit1.text:=self.edit1.text+'8';
                          '9': self.edit1.text:=self.edit1.text+'9';
                          '0': self.edit1.text:=self.edit1.text+'0';
                     end;
                  end;
        '+': self.BUSpeedButton14click(self);
        '-': self.BUSpeedButton16click(self);
        '*': self.BUSpeedButton13click(self);
        '/': self.BUSpeedButton15click(self);
        '=',#13:self.BUSpeedButton17click(self);
        else beep;
   end;
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton22Click(Sender: TObject);
begin
   if (self.edit1.text<>'')and(self.edit1.alignment=taLeftJustify) then
       self.edit1.text:=floattostr(-strtofloat(self.edit1.text))
   else
      beep;
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton23Click(Sender: TObject);
begin
   if self.edit1.alignment=taRightJustify then
   begin
      self.edit1.text:='';
      self.edit1.alignment:=taLeftJustify;
   end;
   self.edit1.text:=floattostr(pi);
end;
{******************************************************************************}
procedure TFormCalc.BUSpeedButton24Click(Sender: TObject);
begin
   if self.edit1.alignment=taRightJustify then
   begin
      self.edit1.text:='';
      self.edit1.alignment:=taLeftJustify;
   end;
   try
     self.edit1.text:=IntToStr(trunc(strtofloat(self.edit1.text)));
   except
     self.edit1.text:='';
     beep;
   end;
end;
{******************************************************************************}
end.
