{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvFormGroups.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvFormGroups;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, JvDirectories, FileCtrl, Buttons,
  JvSpeedButton;

type
  TFormGroup = class(TForm)
    Image1: TImage;
    Bevel1: TBevel;
    StaticText1: TStaticText;
    Edit1: TEdit;
    TreeView1: TTreeView;
    BUDirectories1: TJvDirectories;
    BUButton1: TJvSpeedButton;
    BUButton2: TJvSpeedButton;
    BUButton3: TJvSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    procedure Search(path: string; Node: TTreeNode);
  public
    GroupName:string;
  end;


implementation

{$R *.DFM}

{************************************************************}
procedure TFormGroup.Search(path:string;Node:TTreeNode);
var
   t:TSearchRec;
   res:Integer;
   n:TTreeNode;
   ts:TstringList;
begin
   ts:=TstringList.Create;
   if (path<>'')and(path[length(path)]<>'\') then path:=path+'\';
   res:=findfirst(path+'*.*',faAnyFile,t);
   while res=0 do
   begin
      if (t.name<>'.') and (t.name<>'..') then
        if DirectoryExists(path+t.name) then //include FileCtrl for this function
            ts.Add(t.name);
      res:=FindNext(t);
   end;
   findclose(t);

   ts.Sort;
   for res:=0 to ts.Count-1 do
   begin
      n:=self.TreeView1.Items.AddChild(Node,ts[res]);
      n.Text:=ts[res];
      Search(path+ts[res],n);
   end;
     
   ts.free;
end;
{************************************************************}
procedure TFormGroup.FormShow(Sender: TObject);
begin
   self.TreeView1.Items.Clear;
   Search(self.BUDirectories1.Programs,nil)
end;
{************************************************************}
procedure TFormGroup.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
   self.Edit1.Text:=GroupName;
   while Node<>nil do
   begin
      self.edit1.text:=Node.text+'\'+self.edit1.text;
      Node:=Node.Parent;
   end;
end;
{************************************************************}
procedure TFormGroup.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   canclose:=self.tag=1;
end;
{************************************************************}
end.
