{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvFormParser.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvFormParser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, JvButton;

type
  TParserInf = class
               StartTag,EndTag:string;
               MustBe,Take:Integer;
  end;
  
  TFormParsers = class(TForm)
    ListBox1: TListBox;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    ComboBox1: TComboBox;
    Edit4: TEdit;
    BUButton1: TJvButton;
    BUButton2: TJvButton;
    BUButton3: TJvButton;
    BUButton4: TJvButton;
    procedure Edit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure BUButton3Click(Sender: TObject);
    procedure BUButton4Click(Sender: TObject);
  private
  public
    procedure LoadFromStr(Value:TstringList);
    function SetFromStr:TstringList;
  end;

implementation

{$R *.DFM}

{*********************************************************************}
procedure TFormParsers.Edit1Change(Sender: TObject);
begin
   if self.listbox1.ItemIndex<>-1 then
      self.listbox1.items[self.listbox1.itemindex]:=(Sender as Tedit).Text;
end;
{*********************************************************************}
procedure TFormParsers.Button1Click(Sender: TObject);
var
   ob:TParserInf;
begin
   ob:=TParserInf.Create;
   ob.StartTag:='';
   ob.EndTag:='';
   ob.MustBe:=-1;
   ob.Take:=0;
   self.listbox1.ItemIndex:=self.listbox1.items.addobject('New',TObject(ob));
   self.ListBox1Click(Sender);
end;
{*********************************************************************}
procedure TFormParsers.ListBox1Click(Sender: TObject);
var
   ob:TParserInf;
begin
   self.GroupBox1.enabled:=true;
   ob:=TParserInf(self.listbox1.items.objects[self.listbox1.itemindex]);
   self.edit1.text:=self.listbox1.items[self.listbox1.itemindex];
   self.edit2.text:=ob.StartTag;
   self.edit3.text:=ob.EndTag;
   self.edit4.text:=IntToStr(ob.MustBe);
   self.ComboBox1.ItemIndex:=ob.Take;
end;
{*********************************************************************}
procedure TFormParsers.Button2Click(Sender: TObject);
var
   i:Integer;
begin
   if self.listbox1.itemindex<>-1 then
   begin
      i:=self.listbox1.itemindex;
      self.listbox1.items.delete(i);
      dec(i);
      if i>=0 then
      begin
         self.listbox1.itemindex:=i;
         self.listbox1click(Sender);
      end
      else
           self.GroupBox1.enabled:=false;
   end;
end;
{*********************************************************************}
procedure TFormParsers.Edit2Change(Sender: TObject);
begin
   if self.listbox1.ItemIndex<>-1 then
      TParserInf(self.listbox1.items.objects[self.listbox1.itemindex]).StartTag:=(Sender as Tedit).Text;
end;
{*********************************************************************}
procedure TFormParsers.Edit3Change(Sender: TObject);
begin
   if self.listbox1.ItemIndex<>-1 then
      TParserInf(self.listbox1.items.objects[self.listbox1.itemindex]).EndTag:=(Sender as Tedit).Text;
end;
{*********************************************************************}
procedure TFormParsers.LoadFromStr(Value:TstringList);
var
   i:Integer;
   ob:TParserInf;
   cap:string;
begin
   i:=0;
   while (i<Value.count) do
   begin
      ob:=TParserInf.Create;
      try
         cap:=Value[i];
         inc(i);
         ob.StartTag:=Value[i];
         inc(i);
         ob.EndTag:=Value[i];
         inc(i);
         ob.MustBe:=StrToInt(Value[i]);
         inc(i);
         ob.Take:=StrToInt(Value[i]);
         inc(i);
      finally
         self.listbox1.items.addobject(cap,TObject(ob));
      end;
   end;
end;
{*********************************************************************}
function TFormParsers.SetFromStr:TstringList;
var
   i:Integer;
begin
   result:=TstringList.Create;
   for i:=0 to self.listbox1.Items.count-1 do
   begin
      result.add(self.listbox1.items[i]);
      result.add(TParserInf(self.listbox1.items.objects[i]).StartTag);
      result.add(TParserInf(self.listbox1.items.objects[i]).EndTag);
      result.add(IntToStr(TParserInf(self.listbox1.items.objects[i]).MustBe));
      result.add(IntToStr(TParserInf(self.listbox1.items.objects[i]).Take));
   end;
end;
{*********************************************************************}
procedure TFormParsers.ComboBox1Change(Sender: TObject);
begin
   if self.listbox1.ItemIndex<>-1 then
      TParserInf(self.listbox1.items.objects[self.listbox1.itemindex]).Take:=(Sender as TCombobox).itemindex;
end;
{*********************************************************************}
procedure TFormParsers.Edit4Change(Sender: TObject);
var
   i:Integer;
begin
   i:=0;
   try
      i:=StrToInt((Sender as Tedit).text);
   except
      beep;
   end;
   if self.listbox1.ItemIndex<>-1 then
      TParserInf(self.listbox1.items.objects[self.listbox1.itemindex]).MustBe:=i;
end;
{*********************************************************************}
procedure TFormParsers.BUButton3Click(Sender: TObject);
begin
   self.tag:=0;
   self.close;
end;
{*********************************************************************}
procedure TFormParsers.BUButton4Click(Sender: TObject);
begin
   self.Tag:=1;
   self.close;
end;
{*********************************************************************}
end.
