{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvId3v1.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvId3v1;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
  JvTypes;

type
  TJvId3v1 = class(TComponent)
  private
    fSongName,fArtist,fAlbum,fcomment,fyear: string;
    fGenre:TGenre;
    FBidonS:string;
    FBidonG:TGenre;
    FFileName: TFileName;
    procedure SetFileName(const Value: TFileName);
  protected
  public
  published
    function ReadTag(FileName: string):boolean;
    function WriteTag(FileName,SongName,Artist,Album,Year,Comment: string;Genre:TGenre):boolean;
    procedure RemoveTag(FileName:string);
    function TagPresent(FileName:string):boolean;
    property FileName:TFileName read FFileName write SetFileName;
    function Genre2string(Genre: TGenre):string;
    property SongName: string read FSongName write FBidonS;
    property Artist: string read FArtist write FBidonS;
    property Album: string read FAlbum write FBidonS;
    property Year: string read FYear write FBidonS;
    property Comment: string read FComment write FBidonS ;
    property Genre:TGenre read FGenre write FBidonG;
  end;

implementation

{******************************************************************************}
function TJvId3v1.Genre2string(Genre:TGenre):string;
begin
   case byte(genre) of
        0 : result:='Blues';
        1 : result:='Classic Rock';
        2 : result:='Country';
        3 : result:='Dance';
        4 : result:='Disco';
        5 : result:='Funk';
        6 : result:='Grunge';
        7 : result:='Hip-Hop';
        8 : result:='Jazz';
        9 : result:='Metal';
        10 : result:='New Age';
        11 : result:='Oldies';
        12 : result:='Other';
        13 : result:='Pop';
        14 : result:='R&B';
        15 : result:='Rap';
        16 : result:='Reggae';
        17 : result:='Rock';
        18 : result:='Techno';
        19 : result:='Industrial';
        20 : result:='Alternative';
        21 : result:='Ska';
        22 : result:='Death Metal';
        23 : result:='Pranks';
        24 : result:='Soundtrack';
        25 : result:='Euro-Techno';
        26 : result:='Ambient';
        27 : result:='Trip-Hop';
        28 : result:='Vocal';
        29 : result:='Jazz+Funk';
        30 : result:='Fusion';
        31 : result:='Trance';
        32 : result:='Classical';
        33 : result:='Instrumental';
        34 : result:='Acid';
        35 : result:='House';
        36 : result:='Game';
        37 : result:='Sound Clip';
        38 : result:='Gospel';
        39 : result:='Noise';
        40 : result:='AlternRock';
        41 : result:='Bass';
        42 : result:='Soul';
        43 : result:='Punk';
        44 : result:='Space';
        45 : result:='Meditative';
        46 : result:='Instrumental Pop';
        47 : result:='Instrumental Rock';
        48 : result:='Ethnic';
        49 : result:='Gothic';
        50 : result:='Darkwave';
        51 : result:='Techno-Industrial';
        52 : result:='Electronic';
        53 : result:='Pop-Folk';
        54 : result:='Eurodance';
        55 : result:='Dream';
        56 : result:='Southern Rock';
        57 : result:='Comedy';
        58 : result:='Cult';
        59 : result:='Gangsta';
        60 : result:='Top 40';
        61 : result:='Christian Rap';
        62 : result:='Pop/Funk';
        63 : result:='Jungle';
        64 : result:='Native American';
        65 : result:='Cabaret';
        66 : result:='New Wave';
        67 : result:='Psychadelic';
        68 : result:='Rave';
        69 : result:='Showtunes';
        70 : result:='Trailer';
        71 : result:='Lo-Fi';
        72 : result:='Tribal';
        73 : result:='Acid Punk';
        74 : result:='Acid Jazz';
        75 : result:='Polka';
        76 : result:='Retro';
        77 : result:='Musical';
        78 : result:='Rock & Roll';
        79 : result:='Hard Rock';
        80 : result:='Folk';
        81 : result:='Folk/Rock';
        82 : result:='National Folk';
        83 : result:='Swing';
        84 : result:='Fast Fusion';
        85 : result:='Bebob';
        86 : result:='Latin';
        87 : result:='Revival';
        88 : result:='Celtic';
        89 : result:='Bluegrass';
        90 : result:='Avantgarde';
        91 : result:='Gothic Rock';
        92 : result:='Progressive Rock';
        93 : result:='Psychedelic Rock';
        94 : result:='Symphonic Rock';
        95 : result:='Slow Rock';
        96 : result:='Big Band';
        97 : result:='Chorus';
        98 : result:='Easy Listening';
        99 : result:='Acoustic';
        100 : result:='Humour';
        101 : result:='Speech';
        102 : result:='Chanson';
        103 : result:='Opera';
        104 : result:='Chamber Music';
        105 : result:='Sonata';
        106 : result:='Symphony';
        107 : result:='Booty Bass';
        108 : result:='Primus';
        109 : result:='Porn Groove';
        110 : result:='Satire';
        111 : result:='Slow Jam';
        112 : result:='Club';
        113 : result:='Tango';
        114 : result:='Samba';
        115 : result:='Folklore';
        116 : result:='Ballad';
        117 : result:='Power Ballad';
        118 : result:='Rhythmic Soul';
        119 : result:='Freestyle';
        120 : result:='Duet';
        121 : result:='Punk Rock';
        122 : result:='Drum Solo';
        123 : result:='Acapella';
        124 : result:='Euro-House';
        125 : result:='Dance Hall';
        else result:='';
   end;
end;
{******************************************************************************}
function TJvId3v1.ReadTag(FileName: string):boolean;
var
  fich: TFileStream;
  tag:TId3v1Tag;
begin
   try
     fich := TFileStream.Create(FileName,fmOpenRead or fmShareDenyWrite);

     fich.Position := fich.Size-128;
     fich.Read(tag,sizeof(tag));
     if tag.Identifier='TAG' then
     begin
       fSongName:=tag.SongName;
       fartist:=tag.Artist;
       falbum:=tag.Album;
       fyear:=tag.Year;
       fcomment:=tag.Comment;
     end
     else
     begin
      fSongName:='';
      fartist:='';
      falbum:='';
      fyear:='';
      fcomment:='';
      fgenre:=TGenre(126);
     end;

     fich.Free;

     result:=true;
   except
     result:=false;
   end;
end;
{*****************************************************************************}
procedure TJvId3v1.RemoveTag(FileName: string);
var
  fich:TFileStream;
  tag:array [0..2] of char;
begin
   fich:=TFileStream.Create(FileName,fmOpenReadWrite or fmShareDenyWrite);
   fich.position:=fich.size-128;
   fich.read(tag,3);

   if tag='TAG' then
     fich.size := fich.size-128;

   fich.free;
end;
{*****************************************************************************}
procedure TJvId3v1.SetFileName(const Value: TFileName);
begin
   FFileName := Value;
   ReadTag(Value);
end;
{*****************************************************************************}
function TJvId3v1.TagPresent(FileName: string): boolean;
var
  fich:TFileStream;
  tag:array [0..2] of char;
begin
   try
     fich:=TFileStream.Create(FileName,fmOpenReadWrite or fmShareDenyWrite);
     fich.position:=fich.size-128;
     fich.read(tag,3);
     result:=tag='TAG';
     fich.Free;
   except
     result:=false;
   end;
end;
{*****************************************************************************}
function TJvId3v1.WriteTag(FileName,SongName,Artist,Album,Year,Comment: string;Genre:TGenre):boolean;
var
  fich: TFileStream;
  tag:TId3v1Tag;
begin
   try
     ZeroMemory(@tag,sizeof(tag));
     if FileExists(FileName) then
     begin
       fich := TFileStream.Create(FileName,fmOpenReadWrite or fmShareExclusive);

       //Remove old tag ?
       if fich.Size>128 then
       begin
         fich.Position := fich.Size-128;
         fich.Read(tag,sizeof(tag));
         if tag.Identifier = 'TAG' then
            fich.Position := fich.Size-128;
       end;

       //Set new tag
       tag.Identifier := 'TAG';
       CopyMemory(@tag.SongName,@SongName[1],30);
       CopyMemory(@tag.Artist,@Artist[1],30);
       CopyMemory(@tag.Album,@Album[1],30);
       CopyMemory(@tag.Year,@Year[1],4);
       CopyMemory(@tag.Comment,@Comment[1],30);
       tag.Genre      := Genre;

       //Write it
       fich.Write(tag,sizeof(tag));
       
       fich.Free;

       result:=true;
     end
     else
       result:=false;
   except
     result:=false;
   end;
end;
{******************************************************************************}
end.
