{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvMemoryInfos.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvMemoryInfos;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, JvTypes,
  ExtCtrls, Forms;

type
  TJvMemoryInfos = class(TComponent)
  private
    FTotalMemory,FFreeMemory,Dummy,FtotalPages,FDispoPages,FRegions,
    FFregions,FMemoryLoad:string;
    Ftimer : TTimer;
    Vitesse : Integer;
    Autorefr:Boolean;
    procedure SetAuto(Auto:boolean);
    procedure SetVitesse(vit2:integer);
  protected
  public
    constructor Create (AOwner: TComponent);override;
  published
    procedure Refresh(Sender: TObject);
    property AutoRefresh:boolean read Autorefr write SetAuto;
    property RefreshDelay:Integer read vitesse write setVitesse;
    property TotalMemory:string read FTotalMemory write Dummy;
    property FreeMemory:string read FfreeMemory write Dummy;
    property NumberOfPages:string read FTotalPages write Dummy;
    property DisponiblePages:string read FDispoPages write Dummy;
    property NumberOfRegions:string read FRegions write Dummy;
    property DisponibleRegions:string read FFregions write Dummy;
    property MemoryLoad:string read FMemoryLoad write Dummy;
  end;

implementation

{*************************************************}
procedure TJvMemoryInfos.Refresh(Sender: TObject);
var
   MemoryStatus:Tmemorystatus;
begin
   GlobalMemoryStatus(MemoryStatus);
   Application.ProcessMessages;
   FtotalMemory:=IntToStr(MemoryStatus.dwTotalPhys);
   FFreeMemory:=IntToStr(MemoryStatus.dwAvailPhys);
   FTotalPages:=IntToStr(MemoryStatus.dwTotalPageFile);
   FDispoPages:=IntToStr(MemoryStatus.dwAvailPageFile);
   Fregions:=IntToStr(MemoryStatus.dwTotalVirtual);
   Ffregions:=IntToStr(MemoryStatus.dwAvailVirtual);
   FMemoryLoad:=IntToStr(MemoryStatus.dwMemoryLoad);
   Application.ProcessMessages;
end;
{*************************************************}
procedure TJvMemoryInfos.SetVitesse(vit2:integer);
begin
   Ftimer.interval:=vit2;
   vitesse:=vit2;
end;
{*************************************************}
procedure TJvMemoryInfos.SetAuto(Auto:boolean);
begin
   ftimer.enabled:=Auto;
   autorefr:=Auto;
end;
{*************************************************}
constructor TJvMemoryInfos.Create (AOwner: TComponent);
begin
   inherited Create (Aowner);
   ftimer:=TTimer.Create(Self);
   ftimer.Interval:=500;
   ftimer.OnTimer:=Refresh;
   ftimer.Enabled:=AutoRefresh;
end;
{*************************************************}
end.
