{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvMousePositionner.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvMousePositionner;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, JvTypes;

type
  TJvMousePositionner = class(TComponent)
  private
    FControl: TControl;
  protected
  public
  published
    property Control:TControl read FControl write FControl;
    procedure Execute(Steps:integer=200;Delay:integer=10);
    procedure ExecuteEx(Dest:TPoint;Steps:integer=200;Delay:integer=10);
  end;

implementation

{**************************************************}
procedure TJvMousePositionner.Execute(Steps:Integer;Delay:integer);
var
  src,dest,tmp:TPoint;
  diffx,diffy:real;
begin
   if Assigned(Control) then
   begin
      While Steps>0 do
      begin
         GetCursorPos(src);
         dest.x:=Control.ClientRect.Left+Control.ClientWidth  div 2;
         dest.y:=Control.ClientRect.Top +Control.ClientHeight div 2;
         dest:=FControl.ClientToScreen(Dest);
         diffx:=(dest.x-src.x)/Steps;
         diffy:=(dest.y-src.y)/Steps;
         tmp.x:=round(src.x+diffx);
         tmp.y:=round(src.y+diffy);
         SetCursorPos(tmp.x,tmp.y);

         sleep(Delay);
         dec(Steps);
      end;
   end;
end;
{**************************************************}
procedure TJvMousePositionner.ExecuteEx(Dest: TPoint; Steps,
  Delay: integer);
var
  src,tmp:TPoint;
  diffx,diffy:real;
begin
   while Steps>0 do
   begin
      GetCursorPos(src);
      diffx:=(dest.x-src.x)/Steps;
      diffy:=(dest.y-src.y)/Steps;
      if (round(diffx)<>0) or (round(diffy)<>0) then
      begin
         tmp.x:=round(src.x+diffx);
         tmp.y:=round(src.y+diffy);
         SetCursorPos(tmp.x,tmp.y);

         sleep(Delay);
      end;
      dec(Steps);
   end;
end;
{**************************************************}
end.
