{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvSerialMaker.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvSerialMaker;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  JvTypes;

type
  TJvSerialMaker = class(TComponent)
  private
    FUsername : string;
    FBase : Integer;
    FSerial : string;
    FBidon : string;
    procedure ChangeUser(User:string);
    procedure ChangeBase(Base:integer);
  protected
  public
  published
    property Username : string read FUsername write ChangeUser;
    property Base : Integer read Fbase write ChangeBase;
    property Serial : string Read FSerial Write FBidon;
    function GiveSerial(Base:Integer;Username:string):string;
    function SerialIsCorrect(Base:Integer;Username:string;Serial:string):boolean;
  end;

implementation

{***************************************************}
procedure TJvSerialMaker.ChangeUser(User:string);
begin
   FUsername:=User;
   FSerial:=GiveSerial(FBase,FUsername);
end;
{***************************************************}
procedure TJvSerialMaker.ChangeBase(Base:integer);
begin
   FBase:=Base;
   FSerial:=GIveSerial(FBase,FUsername);
end;
{***************************************************}
function TJvSerialMaker.GiveSerial(Base:Integer;Username:string):string;
var
   st:string;
   a:Integer;
begin
   st:='Error';
   if (Base<>0) and (Username<>'') then
   begin
      a:=Base*length(Username)+ord(username[1])*666;
      st:=IntToStr(a)+'-';
      a:=Base*ord(username[1])*123;
      st:=st+IntToStr(a)+'-';
      a:=Base+(length(Username)*ord(username[1]))*6613;
      st:=st+IntToStr(a);
   end;
   result:=st;
end;
{***************************************************}
function TJvSerialMaker.SerialIsCorrect(Base:Integer;Username:string;Serial:string):boolean;
begin
   if Username='' then result:=false
   else if Base=0 then result:=false
   else result:=Serial=GiveSerial(Base,Username);
end;
{***************************************************}
end.
