{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvStringListToHtml.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvStringListToHtml;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Printers, comctrls;

type
  TJvStringListToHtml = class(TComponent)
  published
    procedure ConvertToHtml(Value: TStringList;path:string);
    function ConvertToHtmlstringList(Value: TStringList):TstringList;
  end;

implementation

resourcestring
   RC_Html1        =     '<HTML>';
   RC_Html2        =     '<TITLE>TStringList converted with BuyPin Component</TITLE>';
   RC_Html3        =     '<BODY>';
   RC_Html4        =     '<BR>';
   RC_Html5        =     '</BODY>';
   RC_Html6        =     '</HTML>';

{**************************************************}
procedure TJvstringListToHtml.ConvertToHtml(Value: TStringList;path: string);
begin
  ConvertToHtmlstringList(Value).SaveToFile(path);
end;
{**************************************************}
function TJvstringListToHtml.ConvertToHtmlstringList(Value: TStringList): TstringList;
var
 i: Integer;
begin
  result := TStringList.Create;
  result.Add(RC_Html1);
  result.Add(RC_Html2);
  result.Add(RC_Html3);
  for i:=0 to Value.Count-1 do
     result.Add(RC_Html4+Value[i]);
  result.Add(RC_Html5);
  result.Add(RC_Html6);
end;
{**************************************************}
end.
